import pygame
from Classes.Objects.BoardField import BoardField

class World():
    __boardFields:list
    __cardWidth:int = 150
    __cardHeight:int = 200
    __cardOffset:int = 400

    def __init__(self, cardWidth:int=300, cardHeight:int=550, cardOffset:int=400):
        self.__boardFields = []
        self.__cardWidth = cardWidth
        self.__cardHeight = cardHeight
        self.__cardOffset = cardOffset
        self.buildGameWorld()

    def buildGameWorld(self):
        # construct elements arround the playerfield
        # Todo add lifepoint label for player and enemy and make them scriptable
        eRow1Height = 75
        eRow2Height = (self.__cardHeight + 35)
        pRow1Height = ((2 * self.__cardHeight) + 75)
        pRow2Height = ((2 * self.__cardHeight) + self.__cardHeight + 30)

        eDeckPos = pygame.Vector2((self.__cardOffset + ((self.__cardWidth + 10) * 0)), eRow1Height)
        eGravePos = pygame.Vector2((self.__cardOffset + ((self.__cardWidth + 10) * 0)), eRow2Height)
        pGravePos = pygame.Vector2((self.__cardOffset + ((self.__cardWidth + 10) * 5)), pRow1Height)
        pDeckPos = pygame.Vector2((self.__cardOffset + ((self.__cardWidth + 10) * 5)), pRow2Height)

        self.__boardFields.append(BoardField("EnemyDeck", "Enemy", "Deck", eDeckPos, "Assets/Cards/Arena/field.png"))
        self.__boardFields.append(BoardField("EnemyGraveyard", "Enemy", "Grave", eGravePos, "Assets/Cards/Arena/field.png"))
        self.__boardFields.append(BoardField("PlayerDeck", "Player", "Deck", pDeckPos, "Assets/Cards/Arena/field.png"))
        self.__boardFields.append(BoardField("PlayerGraveyard", "Player", "Grave", pGravePos, "Assets/Cards/Arena/field.png"))

        for i in range(5):
            pMonsterPos = pygame.Vector2((self.__cardOffset + ((self.__cardWidth + 10) * i)), pRow1Height)
            pEffectPos = pygame.Vector2((self.__cardOffset + ((self.__cardWidth + 10) * i)), pRow2Height)
            eMonsterPos = pygame.Vector2((self.__cardOffset + ((self.__cardWidth + 10) * (i+1)), eRow1Height))
            eEffectPos = pygame.Vector2((self.__cardOffset + ((self.__cardWidth + 10) * (i+1))), eRow2Height)

            self.__boardFields.append(BoardField("PlayerMonsterField-"+str(i), "Player", "MonsterField", pMonsterPos, "Assets/Cards/Arena/field.png"))
            self.__boardFields.append(BoardField("PlayerEffectField-"+str(i), "Player", "EffectField", pEffectPos, "Assets/Cards/Arena/field.png"))
            self.__boardFields.append(BoardField("EnemyMonsterField-"+str(i), "Enemy", "MonsterField", eMonsterPos, "Assets/Cards/Arena/field.png"))
            self.__boardFields.append(BoardField("EnemySpellTrapField-"+str(i), "Enemy", "EffectField", eEffectPos, "Assets/Cards/Arena/field.png"))
            
    def getBoardFields(self) -> list:
        return self.__boardFields
    
    def getCardWidth(self) -> int:
        return self.__cardWidth
    
    def getCardHeight(self) -> int:
        return self.__cardHeight